include <BOSL2/std.scad>
include <./rosetta.scad>

base = 160; // mm
top = 90; //mm
height = 50;
thickness = 9; // mm
thick_height=7; // mm
delta = 0.01;

// M4
screw_width = 5; //mm
piulitza = 7; // mm
piulitza_h = 4; // mm

base_2 = base/2;
top_2 = top/2 - 1;
top_3 = top_2 - 5;
top_4 = top_2/2;
screw_distance = 33;
inital_screw_angle = -30;

$fn = 180;




difference() {
    union() {
        rosetta(top_3, piulitza_h, screw_width);
        color("lightgreen") translate([0,0,piulitza_h-delta]) cylinder(h=piulitza_h, r=top_3-piulitza_h-1);
        color("lightblue") translate([0,0,piulitza_h*2-delta]) cylinder(h=piulitza_h,r1=top_2-3, r2=top_3);
        //translate([0,0,6])
        //cylinder(h=2,r=top_2,center=true, $fn=segments);
    }
    
    union() {
        color("green") translate([0,0,-5]) {
        // screw holes
        rotate([0,0, inital_screw_angle]) translate([0,screw_distance-screw_width/2,0]) cylinder(20,r=screw_width/2);
        rotate([0,0, inital_screw_angle + 120]) translate([0,screw_distance-screw_width/2,0]) cylinder(20,r=screw_width/2);
        rotate([0,0,inital_screw_angle-120]) translate([0,screw_distance-screw_width/2,0]) cylinder(20,r=screw_width/2);
        
        // cable pass
        cylinder(h=20, r=12.5);
        }
        
        // Thinner disk
        translate([0,0,-2]) cylinder(h=piulitza_h*2, r=top_3*2/3);   
    }    
}
